



(************************************************************************)
(*									*)
(*			Version 1.1a ohne Fehlerchecks 			*)
(*									*)
(************************************************************************)


IMPLEMENTATION MODULE LISTofTEST;

(************************************************************************)
(*                                                                      *)
(*           Version 1.1a fuer Sun/4, SunOS 4.1.1, m2c-Compiler         *)
(*     Version 1.1b fuer IBM-PC/AT, MSDOS 3.30, Taylor Modula-2 3.00    *)
(*     Version 1.1c fuer IBM-PC/AT, MSDOS 3.30, Fitted Modula-2 2.00    *)
(*                                                                      *)
(*                    (c) Richard Breuer 1990, 1991                     *)
(*            e-mail: ricki@rwthi3.informatik.rwth-aachen.de            *)
(*              mail: Brunssumstr. 6, 5100 Aachen, Germany              *)
(*                                                                      *)
(************************************************************************)
(*                                                                      *)
(* Aufgabe:                                                             *)
(*                                                                      *)
(*   Das  Implementationsmodul hat nur  die Aufgabe,  im Modulrumpf die	*)
(*   Prozedur LISTCreateClass aufzurufen,  um die Klasse fuer _anyType-	*)
(*   Werte zu erzeugen.  Ausserdem wird hier die  Ordnungsrelation fuer	*)
(*   die Klasse definiert.						*)
(*                                                                      *)
(************************************************************************)
(*                                                                      *)
(* Bemerkungen: ( * = WICHTIG )						*)
(*                                                                      *)
(*  *(1) Keinesfalls das VAR bei der Deklaration von Cmp_anyType ent-	*)
(*	 fernen, sonst werden die Ergebnisse aeusserst interessant	*)
(*	 (und falsch...) sein. (M2C,FM2)				*)
(*  *(2) Trotz des VAR bei der Deklaration von Cmp_anyType duerfen die	*)
(*	 Parameter i und j nicht veraendert werden, sonst frueher oder	*)
(*	 spaeter: GRABSTEIN... (M2C,FM2)				*)
(*                                                                      *)
(************************************************************************)
(*                                                                      *)
(* Aenderungen:                                                         *)
(*                                                                      *)
(*   12 Mar 91	Verwendung von _ anstelle von @, um die Bearbeitung der	*)
(*		Dateien mit m4 zu ermeoglichen. Folgende Strings sind	*)
(*		zu ersetzen (alle in Kleinschrift!)			*)
(*			_anyType	Name des zu verwendenden Typs	*)
(*			_Import		Fuer Nicht-Standardtypen muss	*)
(*					hier ein IMPORT-Statement ein-	*)
(*					gesetzt werden			*)
(*			_Reldef		Definition der Ordnungsrelation	*)
(*					fuer i und j			*)
(*   10 Mar 91	Version 1.1c [BR]					*)
(*   28 Feb 91	Versionen 1.1a,1.1b [BR]				*)
(*   23 Feb 91	Systematische Anpassung an geaendertes SETof_anytype	*)
(*		[BR]							*)
(*   27 Sep 90  Versionen 1.0a,1.0b [BR]                                *)
(*                                                                      *)
(************************************************************************)

  FROM SYSTEM IMPORT
    TSIZE;

  FROM LISTs IMPORT
    LISTCreateClass,
    LISTCompareProcType,
    LISTCompareResultType;



FROM TESTdef IMPORT TEST;


  PROCEDURE CmpTEST(VAR i,j: TEST): LISTCompareResultType;
  (* Beachte Bemerkungen (2),(3) im Kopfkommentar *)

  BEGIN
    (* Hier ist die Ordnungsrelation fuer i und j zu definieren *)


	IF (i.KEY1<j.KEY1) THEN RETURN(LISTLess) END;
	IF (i.KEY1>j.KEY1) THEN RETURN(LISTGreater) END;
	IF (i.KEY2<j.KEY2) THEN RETURN(LISTLess) END;
	IF (i.KEY2>j.KEY2) THEN RETURN(LISTGreater) END;
	RETURN(LISTEqual)


  END CmpTEST;

BEGIN
  (* Erzeugen der Mengenklasse fuer TEST-Daten *)
  (* Der m2c-Compiler erlaubt eine type cast mit Prozedurtypen. Deshalb kann
     in der UNIX-Version die obige Deklaration von Cmp_anyType benutzt werden.
     Es muss aber VAR in der Parameterliste benutzt werden, damit die Prozedur
     kompatibel zu LISTCompareProcType, d.h. PROCEDURE(ADDRESS,ADDRESS) ist.
     Eine generische Prozedurdeklaration mit call-by-value-Parametern
     funktioniert nicht (man kann zwar mit ARRAY OF BYTE arbeiten, aber dann
     muss in Cmp_anyType kopiert werden, weil die type cast nicht funktio-
     niert) *)
  LISTCreateClass(LISTCompareProcType(CmpTEST),TSIZE(TEST),
		  LISTofTESTclass)
END LISTofTEST.

